package bg.bas.dcl.general;

import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Scanner;

import bg.bas.dcl.inflection.FlectionModel;
import bg.bas.dcl.inflection.Form;
import bg.bas.dcl.inflection.InflectionGenerator;
import bg.bas.dcl.semantic.lexical_db.BulNet;

public class MWEFlexTypeSorter {
	
	public static FileHandler fh = new FileHandler();
	Search ss = new Search();
	
	public ArrayList<String> persons = new ArrayList<String>();
	public HashMap<String, String> models = new HashMap<String, String>();
	public BulNet bulnet ;
	
	public ArrayList<String> confirmed = 
			new ArrayList<String>();
	
	
	public static void main (String[] args){
		
		MWEFlexTypeSorter fts = new MWEFlexTypeSorter();
		
		String inDir = "/home/ivelina/WORK-DCL/MWE-DICTS/"
				+ "MWE-DICT-20170501/DATA/NEs/NEs-original-checked/";
		String outDir = "/home/ivelina/WORK-DCL/MWE-DICTS/"
				+ "MWE-DICT-20170501/DATA/NEs/NEs-sorted/";

		String outDir1 = "/home/ivelina/WORK-DCL/MWE-DICTS/"
				+ "MWE-DICT-20170501/DATA/NEs/NEs-sorted-score/";
		String outDir2 = "/home/ivelina/WORK-DCL/MWE-DICTS/"
				+ "MWE-DICT-20170501/DATA/NEs/NEs-sorted-examples/";

		String xmlfile = "/home/ivelina/WORK-DCL/WORDNETS/"
				+ "wnbg_22.04.2019.xml";
		
		String lf = "/home/ivelina/WORK-DCL/"
				+ "INFLECTION/CHECK_VALID_FORMS/"
				+ "nonNEs.tsv_f_checked.txt"; 
		String outfilep = "/home/ivelina/WORK-DCL/"
				+ "INFLECTION/persons.txt"; 
		
		fts.persons = InitialParametersReader.readListFromFile(outfilep);
		
		fts.bulnet = new BulNet(xmlfile);
		
		fts.confirmed.addAll(
				InitialParametersReader.readDictionaryFromFile(lf, 0, 1).keySet()
				);
		
//		fts.sortMWETypes(inDir, outDir);
//		fts.scoreMWEs(outDir, outDir1, outDir2);
		
		String inprev="D:\\WORK-DCL\\Inflection\\2019\\PREVIOUS_DONE\\";
		String indir="D:\\WORK-DCL\\Inflection\\2019\\TO_DO\\";
		String in1="D:\\WORK-DCL\\Inflection\\2019\\BulNet-MWE-2comp.txt";
		String out1="D:\\WORK-DCL\\Inflection\\2019\\MWE-list.txt";
		
//		fts.verifyMWEs(inprev, indir, in1, out1);
		String modf = "/home/ivelina/WORK-DCL/INFLECTION/"
				+ "flect-types.txt";
		fts.readModels(modf);
	
		String neDir = "/home/ivelina/WORK-DCL/INFLECTION/"
				+ "2019/DONE/NOMINAL-SORTED/";
		String outfne = "/home/ivelina/WORK-DCL/INFLECTION/"
				+ "2019/NEs.tsv";
		String nonneDir = "/home/ivelina/WORK-DCL/INFLECTION/"
				+ "2019/CHECKED2/";
		String outfnonne = "/home/ivelina/WORK-DCL/INFLECTION/"
				+ "2019/nonNEs.tsv";

//		fts.processSortedMWEs( neDir,  outfne);
		fts.processNonMWEs( nonneDir,  outfnonne);
	}
	
	public void readModels(String f){
		try{
			Scanner s = new Scanner(new File(f));
			while (s.hasNextLine()){
				String line = s.nextLine();
				if (line.startsWith("#")) continue;
				if (!line.contains("=")) continue;
				
				String key = line.split("=")[0].trim();
				models.put(key, line.trim());
			}
			s.close();
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	public void processSortedMWEs( String neDir, String outf) {
		
		try {
			
		ArrayList<String> domains = new ArrayList<String>();
		domains.add("Географски понятия");
		domains.add("Ботанически понятия");
		domains.add("Зоологически понятия");
		domains.add("Гъби");
		domains.add("Астрономически понятия");
		domains.add("Събития");
		domains.add("Лични имена");
		domains.add("Продукти");
		domains.add("Организации");
		domains.add("Химически понятия");

		HashMap<String,String> abbrev = new HashMap<String,String>();
		abbrev.put("Географски понятия","Геогр.");
		abbrev.put("Ботанически понятия","Ботан.");
		abbrev.put("Зоологически понятия","Зоол.");
		abbrev.put("Гъби","Гъби");
		abbrev.put("Астрономически понятия","Астрон.");
		abbrev.put("Събития","Събития");
		abbrev.put("Лични имена","Лични");
		abbrev.put("Продукти","Прод.");
		abbrev.put("Организации","Орг.");
		abbrev.put("Химически понятия","Хим.");

		HashMap<String,ArrayList<String>> dictNE = 
				new HashMap<String,ArrayList<String>>();
		HashMap<String,ArrayList<String>> dictnonNE = 
				new HashMap<String,ArrayList<String>>();
			
		Writer wr = new OutputStreamWriter(
				new FileOutputStream(outf),
						"UTF-8");

		List<File> list2 = fh.getFileListing(new File(neDir));
		
		for (File f : list2) {
			if (!f.isFile()) continue;
			

			 Scanner s = new Scanner(f,"UTF-8");
			 while (s.hasNextLine()) {
				 String l = s.nextLine().trim();
				 if (l.length() == 0) continue;
				 if (l.startsWith("#")) continue;
				 
				 String[] data = l.split("\t");
				 
					String dom = "Общо знание";
					if (data[2].equals("G")) dom = "Географски понятия";
					if (data[2].equals("C")) dom = "Астрономически понятия";
					if (data[2].equals("E")) dom = "Събития";
					if (data[2].equals("A")) dom = "Организации";
					if (data[2].equals("J")) dom = "Продукти";
					if (data[2].equals("R")) dom = "Лични имена";
					if (data[2].equals("B")) dom = "Ботанически понятия";
					if (data[2].equals("Z")) dom = "Зоологически понятия";
					if (data[2].equals("U")) dom = "Гъби";

				 
				 if (!dictNE.containsKey(dom)){
					 dictNE.put(dom, new ArrayList<String>());
				 }

				  
				 if (!dictNE.get(dom).contains(l)){
					 dictNE.get(dom).add(l);
				 }
			 }
			 
			 s.close();
		}

		
		for (String dom : dictNE.keySet()) {
			
			wr.write("<h2>"+dom+"</h2>\n");
			wr.flush();
			
m:			for (String worddata : dictNE.get(dom)){
				System.out.println(worddata);
				String[] data = worddata.split("\t");
				
				
				String dic = "";
				String wik = "";
				String bulnc = "";
				
				for (int i = 0; i<10; i++)
					if (worddata.startsWith(""+i)) continue m;
				
				String type = data[1];
				
				wr.write("<button class=\"collapsible\">"
						+ data[0]+" ");
				
				if (data[2].equals("G")
						|| data[2].equals("C")
						|| data[2].equals("E")
						|| data[2].equals("A")
						|| data[2].equals("J")
						|| data[2].equals("R")) {
					wr.write("<div id=\"nebox\">собств.</div> ");
				}else if (data[2].equals("B")
						|| data[2].equals("Z")
						|| data[2].equals("U")){
					if (data[0].toLowerCase().equals(data[0])){
						wr.write("<div id=\"nebox\">нариц.</div> ");
					} else {
						wr.write("<div id=\"nebox\">собств.</div> ");					
					}
				} else {
					wr.write("<div id=\"nebox\">нариц.</div> ");
					
				}

				
				wr.write("<div id=\"domain\">"+dom.substring(0,5)+"</div> ");
//				if (dic.length()>0) wr.write("<div id=\"dictbox\">"+dic+"</div> ");
				
				wr.write("<div id=\"typebox\">"+type+"</div> ");

				wr.write("<div id=\"grambox\">"+"No modif"+"</div> ");
				wr.write("<div id=\"grambox1\">"+"No ext"+"</div> ");
				wr.write("<div id=\"grambox2\">"+"Fixed WO"+"</div> ");

				if (bulnet.getAllSynsetsContainingLiteral(data[0]).size()>0){
					wr.write("<div id=\"dictbox\">"+
							bulnet
							.getAllSynsetsContainingLiteral
							(data[0]).get(0).ID
							+"</div> ");
				}
				if (data[3].contains("wiki")){
					wr.write("<div id=\"dictbox1\">"+
							"Wikipedia"
							+"</div> ");
				}
				if (data[3].contains("corpus")){
					wr.write("<div id=\"dictbox2\">"+
							"БНК"
							+"</div> ");
				}
				
				
				wr.write("</button>\n");
				
				wr.write("<div class=\"content\">\n<p>\n<ul>");
				
	        	  System.out.println("X:"+data[0]);
	        	  System.out.println("X:"+models.get(data[1]));
	        	  FlectionModel fm = new FlectionModel(
	        			  models.get(data[1]));
	        	  System.out.println(data[1]);
	        	  ArrayList<Form> forms = 
	        			  fm.generateForms( data[0]);
	        	  
	        	  
	        	  for (Form f : forms) {
	        		  wr.write("<li>"
	        			  +f.form 
	        			  +" <div id=\"formbox\">" 
	        			  //+f.POS
	        			  +f.tags
	        			  + "</div></li>\n");
	        	  }

				
				wr.write("</ul>\n</p>\n</div>\n");
				wr.flush();
				
			}
			
			
		}
		
		 
		wr.flush();
		wr.close();
		

		} catch(Exception e){
			e.printStackTrace();
		}

	}
	
	  /**
		JCheckBox aspect = new JCheckBox("Другият вид е валиден +");
		JCheckBox external = new JCheckBox("Външни |");
		JCheckBox modifx = new JCheckBox("XP модификатор /");
		JCheckBox modif = new JCheckBox("NP модификатор @");
		JCheckBox vorderx = new JCheckBox("Само XP_V ^");
		JCheckBox vorder = new JCheckBox("Само V_XP %");
		JCheckBox fixed = new JCheckBox("_XP неизм. ?");
		JCheckBox onlydef = new JCheckBox("Само чл. £");
		JCheckBox nodef = new JCheckBox("Само нечл. $");
		JCheckBox nosing = new JCheckBox("Само мн.ч. ~");
		JCheckBox noplural = new JCheckBox("Само ед.ч. #");
		JCheckBox NE = new JCheckBox("Именувана същност &");
		JCheckBox error = new JCheckBox("Невалидна единица *");
		JCheckBox error = new JCheckBox("Друг тип !");
	   */
	
	// num = 1 sg., 2 pl., 0 all; def = 0 undef, 1 def, 2 all
	public String getRealType(String type, int num, int def){
		
		String model =  models.get(type);
		
		String mod = "";
		String realmod = "";
		if (model.contains("=")){
			mod = model.substring(model.indexOf("=")+1)
					.trim();
			
		}
		String[] mods = mod.split("\\+");
		for (String mmod : mods) {
			mmod = mmod.trim();
			if (num==1 && def==0){
				if (!mmod.contains("p")
					&& !mmod.contains("l")
					&& !mmod.contains("h")
					&& !mmod.contains("b")
					&& !mmod.contains("d")){
					if (realmod.length()>0){
						realmod += " + ";
					}
					realmod += mmod;
				}
			}
			if (num==2 && def==0){
				if (!mmod.contains("s")
					&& !mmod.contains("l")
					&& !mmod.contains("h") 
					&& !mmod.contains("d")){
					if (realmod.length()>0){
						realmod += " + ";
					}
					realmod += mmod;
				}
			}
			if (num==0 && def==0){
				if (!mmod.contains("l")
					&& !mmod.contains("h") 
					&& !mmod.contains("d")){
					if (realmod.length()>0){
						realmod += " + ";
					}
					realmod += mmod;
				}
			}

			if (num==1 && def==1){
				if (!mmod.contains("p")
					&& !mmod.contains("o")
					&& !mmod.contains("b")){
					if (realmod.length()>0){
						realmod += " + ";
					}
					realmod += mmod;
				}
			}
			if (num==2 && def==1){
				if (!mmod.contains("s")
					&& !mmod.contains("o")){
					if (realmod.length()>0){
						realmod += " + ";
					}
					realmod += mmod;
				}
			}
			if (num==0 && def==1){
				if (!mmod.contains("o")){
					if (realmod.length()>0){
						realmod += " + ";
					}
					realmod += mmod;
				}
			}	
			
			if (num==1 && def==2){
				if (!mmod.contains("p") 
					&& !mmod.contains("b")){
					if (realmod.length()>0){
						realmod += " + ";
					}
					realmod += mmod;
				}
			}
			if (num==2 && def==2){
				if (!mmod.contains("s") ){
					if (realmod.length()>0){
						realmod += " + ";
					}
					realmod += mmod;
				}
			}
			if (num==0 && def==2){
				 	if (realmod.length()>0){
						realmod += " + ";
					}
					realmod += mmod;
				 
			}			
		}
		
		String newtype = type;
		for (String modID : models.keySet()){
			if (models.get(modID)
					.equals(modID + "= " + realmod)){
				newtype = modID;
				break;
			}
			
		}
		
		return newtype+"= "+realmod;

	}
	
	
	public void processNonMWEs( String dir, String outf) {
		
		try {
			
		ArrayList<String> domains = new ArrayList<String>();
		domains.add("Географски понятия");
		domains.add("Ботанически понятия");
		domains.add("Зоологически понятия");
		domains.add("Гъби");
		domains.add("Астрономически понятия");
		domains.add("Събития");
		domains.add("Лични имена");
		domains.add("Продукти");
		domains.add("Организации");
		domains.add("Химически понятия");
		domains.add("Закони");
		domains.add("Математика");
		domains.add("Медицина");
		domains.add("Технологии");

		HashMap<String,String> abbrev = new HashMap<String,String>();
		abbrev.put("Общо знание","Общи");
		abbrev.put("Географски понятия","Геогр.");
		abbrev.put("Ботанически понятия","Ботан.");
		abbrev.put("Зоологически понятия","Зоол.");
		abbrev.put("Гъби","Гъби");
		abbrev.put("Астрономически понятия","Астрон.");
		abbrev.put("Събития","Събития");
		abbrev.put("Лични имена","Лични");
		abbrev.put("Продукти","Прод.");
		abbrev.put("Организации","Орг.");
		abbrev.put("Химически понятия","Хим.");
		abbrev.put("Закони","Закони");
		abbrev.put("Математика","Мат.");
		abbrev.put("Медицина","Мед.");
		abbrev.put("Технологии","Техн.");

 		HashMap<String,HashMap<String,String>> dictnonNE = 
				new HashMap<String,HashMap<String,String>>();
			
		Writer wr = new OutputStreamWriter(
				new FileOutputStream(outf),
						"UTF-8");
		Writer wr_f = new OutputStreamWriter(
				new FileOutputStream(outf+"_selected.txt"),
						"UTF-8");
		Writer wr_forms = new OutputStreamWriter(
				new FileOutputStream(outf+"_forms.txt"),
						"UTF-8");

		int imena = 0;
		
		List<File> list2 = fh.getFileListing(new File(dir));
		
		for (File f : list2) {
			if (!f.isFile()) continue;
			

			 Scanner s = new Scanner(f,"UTF-8");
			 while (s.hasNextLine()) {
				 String l = s.nextLine().trim();
				 if (l.length() == 0) continue;
				 
				 String[] data = l.split("\t");
				 if (data.length<2) continue;
				 
				 String word = data[0].trim();
				 String type = data[1];
 				 
					word = word
							.replace("#","")
							.replace("$","")
							.replace("£","")
							.replace("~","")
							.replace("@","")
							.replace("%","")
							.replace("&","")
							.replace("*","")
							.replace("!","")
							;

//				 if (domaindict.containsKey(word)){
//					 dom = domaindict.get(word);
//				 }
				 
					String dom = "Общо знание";
					
					if (data.length>2) {
						if (data[2].equals("H")) dom = "Химически понятия";
						if (data[2].equals("G")) dom = "Географски понятия";
						if (data[2].equals("B")) dom = "Ботанически понятия";
						if (data[2].equals("Z")) dom = "Зоологически понятия";
						if (data[2].equals("C")) dom = "Астрономически понятия";
						if (data[2].equals("E")) dom = "Събития";
						if (data[2].equals("R"))  dom = "Лични имена"; 
						if (data[2].equals("O")) dom = "Организации";
						if (data[2].equals("J")) dom = "Продукти";
						if (data[2].equals("L")) dom = "Закони";
						if (data[2].equals("M")) dom = "Математика";
						if (data[2].equals("N")) dom = "Медицина";
						if (data[2].equals("T")) dom = "Технологии";
					}
				  
					System.out.println(l);
					System.out.println(word+" "+type);

				 if (!dictnonNE.containsKey(dom)){
					 dictnonNE.put(dom, new HashMap<String,String>());
				 }

				  
				 if (!dictnonNE.get(dom).containsKey(word)){
					 dictnonNE.get(dom).put(word,l);
				 }
			 }
			 
			 s.close();
		}

		
		
		for (String dom : dictnonNE.keySet()) {
			
			ArrayList<String> keys = new ArrayList<String>();
			keys.addAll(dictnonNE.get(dom).keySet());
			Collections.sort(keys);
			
			wr.write("<h2>"+dom+"</h2>\n");
			wr.flush();
			
m:			for (String wordkey : keys){
	 
				String worddata = dictnonNE.get(dom).get(wordkey);
				String[] data = worddata.split("\t");
				
				if (data.length<2) continue;
				
				 String word = data[0].trim();
				 String type = data[1];
				 				 
				 String[] ws =  word.split(" ");
				 if (ws.length<2) continue;
				 
				 String wordlast = ws[ws.length-1];
				 
//				 if ((persons.contains(word)
//						 || persons.contains(wordlast))
//						 && type.endsWith("B")) {
//					 type = type.substring(0,type.length()-1);
//					 if (type.endsWith("X")) 
//						 type = type.substring(0,type.length()-1);
//				 } 
				
				 /*
		JCheckBox onlydef = new JCheckBox("Само чл. £");
		JCheckBox nodef = new JCheckBox("Само нечл. $");
		JCheckBox nosing = new JCheckBox("Само мн.ч. ~");
		JCheckBox noplural = new JCheckBox("Само ед.ч. #");
		JCheckBox NE = new JCheckBox("Именувана същност &");
		JCheckBox error = new JCheckBox("Невалидна единица *");

				  */
					if (word.contains("*")) continue m;
					if (word.contains("!")) continue m;
					
					boolean ne=  !word.equals(word.toLowerCase());
				
				if ( word.contains("#") && word.contains("$") ){
					 String newtype = getRealType(type,1,0);
					if (newtype.startsWith(type+"=")) {
						System.out.println(newtype.replace("=","S0=")); 
						type = type+"S0";
						models.put(type ,newtype);
					}else {
						type=newtype.substring(0,newtype.indexOf("="));
						System.out.println(newtype);
					}
					
				} else if ((word.contains("#") && word.contains("£"))
					|| type.endsWith("SD")){
				if (type.endsWith("SD")) type=type.substring(0,type.length()-2);
				
					
					String newtype = getRealType(type,1,1);
					if (newtype.startsWith(type+"=")) {
						System.out.println(newtype.replace("=","SD=")); 
						type = type+"SD";
						models.put(type ,newtype);
					}else {
						type=newtype.substring(0,newtype.indexOf("="));
						System.out.println(newtype);
					}
					
				} else if ( word.contains("~") && word.contains("$") ){
				 	
					String newtype = getRealType(type,2,0);
					if (newtype.startsWith(type+"=")) {
						System.out.println(newtype.replace("=","P0=")); 
						type = type+"P0";
						models.put(type ,newtype);
					}else {
						type=newtype.substring(0,newtype.indexOf("="));
						System.out.println(newtype);
					}
					
				} else if ((word.contains("~") && word.contains("£"))
					|| type.endsWith("PD")){
				if (type.endsWith("PD")) type=type.substring(0,type.length()-2);
				
					
					String newtype = getRealType(type,2,1);
					if (newtype.startsWith(type+"=")) {
						System.out.println(newtype.replace("=","PD=")); 
						type = type+"PD";
						models.put(type ,newtype);
					}else {
						type=newtype.substring(0,newtype.indexOf("="));
						System.out.println(newtype);
					}
					
				} else if (word.contains("#") || type.endsWith("S")) {
					if (type.endsWith("S")) type=type.substring(0,type.length()-1);
					
					String newtype = getRealType(type,1,2);
					if (newtype.startsWith(type+"=")) {
						System.out.println(newtype.replace("=","S=")); 
						type = type+"S";
						models.put(type ,newtype);
					}else {
						type=newtype.substring(0,newtype.indexOf("="));
						System.out.println(newtype);
					}
 				} else if (word.contains("~") || type.endsWith("P")) {
					if (type.endsWith("P")) type=type.substring(0,type.length()-1);
					String newtype = getRealType(type,2,2);
					if (newtype.startsWith(type+"=")) {
						System.out.println(newtype.replace("=","P=")); 
						type = type+"P";
						models.put(type ,newtype);
					}else {
						type=newtype.substring(0,newtype.indexOf("="));
						System.out.println(newtype);
					}
				
				}else if (word.contains("$") ) {
					 
					String newtype = getRealType(type,0,0);
					if (newtype.startsWith(type+"=")) {
						System.out.println(newtype.replace("=","0=")); 
						type = type+"0";
						models.put(type ,newtype);
					}else {
						type=newtype.substring(0,newtype.indexOf("="));
						System.out.println(newtype);
					}
				
				}else if (word.contains("£") || type.endsWith("D")) {
					if (type.endsWith("D")) type=type.substring(0,type.length()-1);
					
					String newtype = getRealType(type,0,1);
					if (newtype.startsWith(type+"=")) {
						System.out.println(newtype.replace("=","D=")); 
						type = type+"D";
						models.put(type ,newtype);
					}else {
						type=newtype.substring(0,newtype.indexOf("="));
						System.out.println(newtype);
					}
				
				}  

				word = word
						.replace("#","")
						.replace("$","")
						.replace("£","")
						.replace("~","")
						.replace("@","")
						.replace("%","")
						.replace("&","")
						.replace("*","")
						.replace("!","")
						;
				
				if (ne && type.contains("S")) word = word.substring(0,1).toUpperCase()
						+ word.substring(1);
				
				String outline = "";
				outline += ("<button class=\"collapsible\">"
						+ word+" ");
				
				
				outline += "<div id=\"domain\">"+abbrev.get(dom)+"</div> ";
//				if (dic.length()>0) outline += "<div id=\"dictbox\">"+dic+"</div> ");
				
				if (ne) 
					outline += "<div id=\"nebox\">"+"име"+"</div> ";
				
				outline += "<div id=\"typebox\">"+type+"</div> ";

//				outline += "<div id=\"grambox\">"+"без мод."+"</div> ";
//				outline += "<div id=\"grambox1\">"+"прит. мест."+"</div> ";
				outline += "<div id=\"grambox2\">"+"фикс."+"</div> ";

				String bulnetid = "";
				String wikiid = "";
				if (bulnet.getAllSynsetsContainingLiteral(data[0]).size()>0){
					bulnetid = bulnet
							.getAllSynsetsContainingLiteral
							(data[0]).get(0).ID;
					
					if (!bulnet.get(bulnetid).definition
							.contains("MT!")
							&& !bulnet.get(bulnetid).definition
							.contains("MTL!")
							&& !bulnet.get(bulnetid).definition
							.contains("Define me"))
					
					outline += ("<div id=\"dictbox\" title=\""+
							bulnet.get(bulnetid).getLiterals()
							+" "
							+bulnet.get(bulnetid).definition
							+"\">"+
							bulnetid
							+"</div> ");
				}
				
				 
				if (data.length>3 && data[3].contains("wiki")){
					wikiid = "Wikipedia";
					outline += ("<div id=\"dictbox1\">"+
							"Wikipedia"
							+"</div> ");
				}
			/*
				if (data[3].contains("corpus")){
					wr.write("<div id=\"dictbox2\">"+
							"БНК"
							+"</div> ");
				}
			*/
				
				outline += ("</button>\n");
				
				outline += ("<div class=\"content\">\n<p>\n<ul>");
				
	        	  System.out.println("X:"+data[0]);
	        	  System.out.println("X:"+ type );
	        	  FlectionModel fm = new FlectionModel(
	        			  models.get(type)); 
	        	  
	        	  ArrayList<Form> forms = 
	        			  fm.generateForms(word);
	        	  
	        	  String fforms = "";int conf = 0; int fnum = 0;
	        	  int confs = 0; int confp = 0;
	        	  
	        	  for (Form f : forms) {
	        		  
	        		  String pos = f.POS;
	        		  if (pos.contains("NHN")) pos = "NN";
	        		  if (pos.contains("NHM")) pos = "NM";
	        		  if (pos.contains("NHF")) pos = "NF";
	        		  if (pos.contains("NHO")) pos = "NO";
	        		  
	        		  fnum++;
	        		  if (confirmed.contains(f.form)) {
	        			  conf++;
	        			  if (f.tags.contains("s")) confs++;
	        			  if (f.tags.contains("p")) confp++;
	        		  }
	        		  
	        	  }
	        	  
	        	  for (Form f : forms) {
	        		  
	        		  String pos = f.POS;
	        		  if (pos.contains("NHN")) pos = "NN";
	        		  if (pos.contains("NHM")) pos = "NM";
	        		  if (pos.contains("NHF")) pos = "NF";
	        		  if (pos.contains("NHO")) pos = "NO";
	        		  
	        		  if (f.form.endsWith("метъра") && f.tags.contains("pb"))
	        			  f.form = f.form.replace("метъра","метра");
	        		  fnum++;
	        		  if (confirmed.contains(f.form)) conf++;

	        		  String formline =  f.form 
	        			  +" <div id=\"formbox\">" 
	        			  +pos
	        			  +f.tags
	        			  +"</div> "
	        			  + (confirmed.contains(f.form)?"&#10004;":"") ;
	        		  
	        		  if ((f.tags.contains("s") && confs == 0)
	        				  || (f.tags.contains("p") && confp == 0)){
	        			  formline = "<font color=\"#BFC9CA\">"
	        					  + formline
	        					  + "</font>";
	        		  }
	        		  
	        		  outline +="<li>"
		        			  +formline
		        			  + "</li>\n";
	        		  
	        		  fforms += f.form + "/"+f.tags+"; ";
	        		  
//	        		  wr_forms.write(f.form+"\t"+f.form+"\n");
//	        		  wr_forms.flush();
	        		  
	        	  }


	        	  wr_forms.write(
	        			 word +"\t"
	        			+type +"\t"
	        			+dom  +"\t"
	        			+(ne?"име":"нариц.")+"\t"
	        			+ bulnetid +"\t"
	        			+ wikiid  
	        			  +"\n");
        		  wr_forms.flush();

//	        	  wr_forms.write(
//	        			  "\t"+ word + "\t"
//	        			  + type + "\t\t" 
//	        			  + fforms
//	        			  + "\n"
//	        			  );
	        	  
				
        		  outline += ("</ul>\n</p>\n</div>\n");
        		  
        		  wr_f.write(worddata);
        		  
        		 if (conf >= fnum/2
           				 && (!dom.equals("Лични имена") 
        						 || bulnetid.length()>0)
       				 && (!dom.equals("Географски понятия") 
        					|| (word.equals(word.toLowerCase()))	 
       						 || bulnetid.length()>0)
        				 && !dom.equals("Продукти")
        				 ){
        			 if (dom.equals("Лични имена")) imena++;
        			 wr.write(outline);
        			 wr.flush();
        			 
        			 if (data.length==2) wr_f.write("\t\t");
        			 if (data.length==3) wr_f.write("\t");
        			 wr_f.write("\tX");
        		 }
        		 wr_f.write("\n");
        		 wr_f.flush();
				
			}
			
			
		}
		
		 
		wr.flush();
		wr.close();
		
		wr_f.flush();
		wr_f.close();
		
		wr_forms.flush();
		wr_forms.close();

		} catch(Exception e){
			e.printStackTrace();
		}

	}

	
	public void processNEMWEs( String neDir, String outf) {
		
		try {
			
		ArrayList<String> domains = new ArrayList<String>();
		domains.add("Географски понятия");
		domains.add("Биологични понятия");
		domains.add("Астрономически понятия");
		domains.add("Събития");
		domains.add("Лични имена");
		domains.add("Продукти");
		domains.add("Организации");
		domains.add("Химически понятия");
			
		HashMap<String,ArrayList<String>> dictNE = 
				new HashMap<String,ArrayList<String>>();
		HashMap<String,ArrayList<String>> dictnonNE = 
				new HashMap<String,ArrayList<String>>();
			
		Writer wr = new OutputStreamWriter(
				new FileOutputStream(outf),
						"UTF-8");

		List<File> list2 = fh.getFileListing(new File(neDir));
		
		for (File f : list2) {
			if (!f.isFile()) continue;
			
			String dom = "Общо знание";
			if (f.getName().contains("Geo")) dom = "Географски понятия";
			if (f.getName().contains("C17")) dom = "Астрономически понятия";
			if (f.getName().contains("E30")) dom = "Събития";
			if (f.getName().contains("J16")) dom = "Продукти";
			if (f.getName().contains("R15")) dom = "Лични имена";
			if (f.getName().contains("R18")) dom = "Лични имена";

			 Scanner s = new Scanner(f,"UTF-8");
			 while (s.hasNextLine()) {
				 String l = s.nextLine().trim();
				 if (l.length() == 0) continue;
				 if (l.startsWith("#")) continue;
				 
				 if (!dictNE.containsKey(dom)){
					 dictNE.put(dom, new ArrayList<String>());
				 }

				  
				 if (!dictNE.get(dom).contains(l)){
					 dictNE.get(dom).add(l);
				 }
			 }
			 
			 s.close();
		}

		
		for (String dom : dictNE.keySet()) {
			
			wr.write("<h2>"+dom+"</h2>\n");
			wr.flush();
			
m:			for (String worddata : dictNE.get(dom)){
				System.out.println(worddata);
				String[] data0 = worddata.split("\t");
				String[] data = data0[0].split(",");
				
				String dic = "";
				String wik = "";
				String bulnc = "";
				
				for (int i = 0; i<10; i++)
					if (worddata.startsWith(""+i)) continue m;
				
				String type = data[1];
				
				wr.write("<button class=\"collapsible\">"
						+ data[0]+" ");
				wr.write("<div id=\"nebox\">собств.</div> ");
				wr.write("<div id=\"domain\">"+dom.substring(0,3)+"</div> ");
//				if (dic.length()>0) wr.write("<div id=\"dictbox\">"+dic+"</div> ");
				
				wr.write("<div id=\"typebox\">"+type+"</div> ");

				wr.write("<div id=\"grambox\">"+"No modif"+"</div> ");
				wr.write("<div id=\"grambox1\">"+"No ext"+"</div> ");
				wr.write("<div id=\"grambox2\">"+"Fixed WO"+"</div> ");

				if (bulnet.getAllSynsetsContainingLiteral(data[0]).size()>0){
					wr.write("<div id=\"dictbox\">"+
							bulnet
							.getAllSynsetsContainingLiteral
							(data[0]).get(0).ID
							+"</div> ");
				}
				if (data0.length>1 && data0[1].contains("wiki")){
					wr.write("<div id=\"dictbox1\">"+
							"Wikipedia"
							+"</div> ");
				}
				if (data0.length>1 && data0[1].contains("corpus")){
					wr.write("<div id=\"dictbox2\">"+
							"БНК"
							+"</div> ");
				}
				
				
				wr.write("</button>\n");
				
				wr.write("<div class=\"content\">\n<p>\n<ul>");
				
	        	  System.out.println("X:"+data[0]);
	        	  System.out.println("X:"+models.get(data[1]));
	        	  FlectionModel fm = new FlectionModel(
	        			  models.get(data[1]));
	        	  System.out.println(data[1]);
	        	  ArrayList<Form> forms = 
	        			  fm.generateForms( data[0]);
	        	  
	        	  
	        	  for (Form f : forms) {
	        		  wr.write("<li>"
	        			  +f.form 
	        			  +" <div id=\"formbox\">" 
	        			  +f.POS+f.tags
	        			  + "</div></li>\n");
	        	  }

				
				wr.write("</ul>\n</p>\n</div>\n");
				wr.flush();
				
			}
			
			
		}
		
		 
		wr.flush();
		wr.close();
		

		} catch(Exception e){
			e.printStackTrace();
		}

	}

	String[] special = {"£", "$", "%", "^", "&", "*", "|"
			, "@", "#", "~", "!", "?","/","+"};
	public void verifyMWEs( String prevDir, String inDir, String inf, String outf) {
		
		try {
			
			HashMap<String,String> dict = new HashMap<String,String>();
			ArrayList<String> prevlist = new ArrayList<String>();
			
		Writer wr = new OutputStreamWriter(
				new FileOutputStream(outf),
						"UTF-8");

		List<File> list2 = fh.getFileListing(new File(prevDir));
		
		for (File f : list2) {
			if (!f.isFile()) continue;
			

			 Scanner s = new Scanner(f,"UTF-8");
			 while (s.hasNextLine()) {
				 String l = s.nextLine();

				 if (!l.contains(",")) continue;
				 
				 l = l.substring(0,l.indexOf(","));
				 for (String ss : special) {
					 l = l.replace(ss, "");
				 }
				 l=l.trim();
//				 System.out.println(l);
				 if (l.length()>0 
						 && !prevlist.contains(l)) prevlist.add(l);
			 }
			 
			 s.close();
		}

		List<File> list1 = fh.getFileListing(new File(inDir));
		
		for (File f : list1) {
			if (!f.isFile()) continue;
			

			 Scanner s = new Scanner(f,"UTF-8");
			 while (s.hasNextLine()) {
				 String l = s.nextLine();

				 if (!l.contains(",")) continue;
				 
				 l = l.substring(0,l.indexOf(","));
				 for (String ss : special) {
					 l = l.replace(ss, "");
				 }
				 l=l.trim();
//				 System.out.println(l);
				 if (l.length()>0 
						 && !prevlist.contains(l)) prevlist.add(l);
			 }
			 
			 s.close();
		}


		Scanner s1 = new Scanner(new File(inf),"UTF-8");

		 while (s1.hasNextLine()) {
			 String l = s1.nextLine();

			 if (!l.contains("\t")) continue;
			 
			 l = l.substring(0,l.indexOf("\t"));
			 
			 if (!l.contains(",")) continue;
			 
			 String[] ld = l.split(",");
			 String word = ld[0].toLowerCase();
			 String type = ld[1];

			 if (prevlist.contains(word)) {
				 System.out.println("DUPLICATE: "+word);
				 continue;
			 } else {
				 String[] comp = word.split(" ");
				 if (comp.length>2) continue;
				 if (type.equals("NF") && comp[0].length()>3 && comp[0].charAt(comp[0].length()-3) == 'я'
						 && (comp[1].charAt(comp[1].length()-1) == 'я'
						 	|| comp[1].charAt(comp[1].length()-1) == 'а')) {
					 type= "NHF12";
//					 wr.write(word+"\t"+type+"\n");
					 wr.flush();
					 continue;
				 }
				 if (type.equals("NF") && comp[1].length()>3 && comp[1].charAt(comp[1].length()-3) == 'я'
						 && (comp[1].charAt(comp[1].length()-1) == 'я'
						 	|| comp[1].charAt(comp[1].length()-1) == 'а')) {
					 type= "NHF13";
//					 wr.write(word+"\t"+type+"\n");
					 wr.flush();
					 continue;
				 }
				 if (type.equals("NF") 
						 && (comp[1].charAt(comp[1].length()-1) != 'я'
						 	&& comp[1].charAt(comp[1].length()-1) != 'а')) {
					 type= "NHF15";
//					 wr.write(word+"\t"+type+"\n");
					 wr.flush();
					 continue;
				 }
				 if (type.equals("NF") 
						 && (comp[1].charAt(comp[1].length()-1) == 'я'
						 	|| comp[1].charAt(comp[1].length()-1) == 'а')) {
					 type= "NHF11";
//					 wr.write(word+"\t"+type+"\n");
					 wr.flush();
					 continue;
				 }
				 if (type.equals("NF")  ) {
					 type= "NHFXX";
					 wr.write(word+"\t"+type+"\n");
					 wr.flush();
					 continue;
				 }


				 if (type.equals("NN") && comp[0].length()>3 && comp[0].charAt(comp[0].length()-3) == 'я'
						 && (comp[1].charAt(comp[1].length()-1) == 'о')) {
					 type= "NHN17";
					 wr.write(word+"\t"+type+"\n");
					 wr.flush();
					 continue;
				 }
				 if (type.equals("NN") && comp[0].length()>3 && comp[0].charAt(comp[0].length()-3) == 'я'
						 && (comp[1].charAt(comp[1].length()-1) == 'е')) {
					 type= "NHN13";
					 wr.write(word+"\t"+type+"\n");
					 wr.flush();
					 continue;
				 }
				 if (type.equals("NN")
						 && (comp[1].equals("време"))) {
					 type= "NHN121";
					 wr.write(word+"\t"+type+"\n");
					 wr.flush();
					 continue;
				 }
				 if (type.equals("NN")
						 && (comp[1].endsWith("ие"))) {
					 type= "NHN18";
					 wr.write(word+"\t"+type+"\n");
					 wr.flush();
					 continue;
				 }
				 if (type.equals("NN")
						 && (comp[1].equals("не"))) {
					 type= "NHN19";
					 wr.write(word+"\t"+type+"\n");
					 wr.flush();
					 continue;
				 }
				 if (type.equals("NN") 
						 && (comp[1].charAt(comp[1].length()-1) == 'о')) {
					 type= "NHN12";
					 wr.write(word+"\t"+type+"\n");
					 wr.flush();
					 continue;
				 }
				 if (type.equals("NN") 
						 && (comp[1].charAt(comp[1].length()-1) == 'е')) {
					 type= "NHN11";
					 wr.write(word+"\t"+type+"\n");
					 wr.flush();
					 continue;
				 }
				 if (type.equals("NN")  ) {
					 type= "NHNXX";
					 wr.write(word+"\t"+type+"\n");
					 wr.flush();
					 continue;
				 }
		 
			 }

		 }
		 
		 s1.close();
		
		 
		wr.flush();
		wr.close();
		

		} catch(Exception e){
			e.printStackTrace();
		}

	}
	
	public void scoreMWEs(String inDir, String outDir, String exoutDir){
		try {
			
			InflectionGenerator ig = new InflectionGenerator();
		HashMap<String,String> dict = new HashMap<String,String>();
			
		List<File> list = fh.getFileListing(new File(inDir));
		
		for (File f : list) {
			if (!f.isFile()) continue;
			
			File outf = new File(f.getAbsolutePath().replace(inDir, outDir));
			if (outf.exists()) continue;
			
			Writer wr = new OutputStreamWriter(
					new FileOutputStream(outf),
							"UTF-8");
			Writer wrex = new OutputStreamWriter(
					new FileOutputStream(
							f.getAbsolutePath().replace(inDir, exoutDir)),
							"UTF-8");

			
			ArrayList<String> MWEs = new ArrayList<String>();
			HashMap<String,String> formtolemma = 
					new HashMap<String,String>();
			HashMap<String,String> original = 
					new HashMap<String,String>();
			
			Scanner s = new Scanner(f);
			
			while (s.hasNextLine()){
				
				String line = s.nextLine().trim();
				
				if (line.equals("")) continue;
				if (line.startsWith("#")) continue;
				
				String[] data = line.split("\t");
				
				String ll = data[0]+","+data[1];
				MWEs.add(data[0]);
				
//				ArrayList<Form> forms = ig.generateForms(ll, "G");
//				
//				for (Form form : forms){
//					MWEs.add(form.form);
//					formtolemma.put(form.form, form.mainform);
//				}

				original.put(data[0], line);
				
			}
			
			s.close();
			
			HashMap<String, MWERecord> alldata = 
					ss.getExamplesMWE(MWEs);
			
			
			for (String mwe : original.keySet()){
				
				String dat = original.get(mwe) ;
				String datex = original.get(mwe) + "\t";
				
				if (alldata.containsKey(mwe)){
					
					if (alldata.get(mwe).examples.size()>0){
						dat = dat.replace("unknown", "corpus");
						datex = datex.replace("unknown", "corpus");
					}
					
						dat += "\t" + alldata.get(mwe).tfreq
						+ "\t" + alldata.get(mwe).dfreq
						+ "\t" + alldata.get(mwe).calculateIDF()
						;

						for (String ex : alldata.get(mwe).examples)	{
							datex += ex + "; ";
						}
						
				}
				
				wr.write(dat+"\n");
				wr.flush();
				
				wrex.write(datex + "\n");
				wrex.flush();

			}
			
			wr.flush();
			wr.close();
			
			wrex.flush();
			wrex.close();
			
		}
		
		
	
		
		} catch(Exception e){
			e.printStackTrace();
		}
	

	}

	
	public void sortMWETypes(String inDir, String outDir){
		try {
			
			HashMap<String,Writer> writers = new HashMap<String,Writer>();
			HashMap<String,String> dict = new HashMap<String,String>();
			
		List<File> list = fh.getFileListing(new File(inDir));
		
		for (File f : list) {
			if (!f.isFile()) continue;
			
			String fname = f.getName();
			String cat = "";
			
			if (fname.contains("G")) cat="G";
			else if (fname.contains("J")) cat="J";
			else if (fname.contains("R")) cat="R";
			else if (fname.contains("C")) cat="C";
			else if (fname.contains("E")) cat="E";
			else if (fname.contains("B")) cat="B";
			else if (fname.contains("Z")) cat="Z";
			else if (fname.contains("U")) cat="U";
			else cat="X";
			
			Scanner s = new Scanner(f);
			
			while (s.hasNextLine()){
				
				String line = s.nextLine().trim();
				if (line.equals("")) continue;
				if (line.startsWith("#")) continue;
				
				if (Character.isDigit(line.charAt(0))) continue;
				if (!Character.isLetter(line.charAt(0))) continue;

				String[] data = line.split("\t");
				
				String source = "unknown";
				if (data.length>1) {
					source = data[1];
				}
				
				String[] worddata = data[0].split(",");

				if (worddata.length<2) continue;
				
				String lemma = worddata[0].trim();
				String flec = worddata[1].trim()
						.replace("G", "H");
				
				String ll = lemma + "\t" 
						+ flec + "\t" 
						+ cat + "\t"
						+ source;
				
				if (dict.containsKey(lemma)
						&& !dict.get(lemma).equals(ll)){
					
					String[] olddata = dict.get(lemma).split("\t");
					
					if (!olddata[1].equals(flec)
							|| olddata[2].equals(cat)){
					
						if (olddata[1].equals(flec)
								&& olddata[2].equals(cat)){
							if (source.equals("wikipedia")
										||
										olddata[3].equals("unknown")){
								dict.put(lemma, ll);
							}
							continue;
						}
						
						System.out.println(dict.get(lemma));
						System.out.println(ll);
						
						continue;
					}
				}
				
				
				dict.put(lemma, ll);
				
			}
			
			s.close();
			
			
		}
		
		int ctr = 0;
		for (String ll : dict.values()){
			String flec = ll.split("\t")[1];
			if (!flec.endsWith("0")) ctr++;
			Writer wr ;
			if (writers.containsKey(flec)) {
				wr = writers.get(flec);
			} else {
				wr = new OutputStreamWriter(
						new FileOutputStream(outDir 
								+ flec + ".csv"),"UTF-8");
				
				writers.put(flec, wr);
			}
			
			wr.write(ll+"\n");
			wr.flush();

		}
		
		for (Writer wr : writers.values()) {
			wr.flush();
			wr.close();
		}
		
		System.out.println(dict.size());
		
		System.out.println("WITH FORMS: "+ctr);
		
	} catch(Exception e){
		e.printStackTrace();
	}

	}

}