package bg.bas.dcl.general;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;
import java.io.Writer;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Scanner;

import org.json.simple.JSONObject;
import org.json.simple.parser.JSONParser;


public class Search {
	
	int N = 3;
	int MAXDIST = 4;
	
	String mainDir = "/home/ivelina/SVN_CORPUS/BulNC/C-MassMedia/";
	String metadataDir = "/home/ivelina/SVN_CORPUS/BulNC-METADATA/";
	
	
	public void getExamples(String word,String dir) {
		
		int nof = 0;
		int now = 0;
		
		FileHandler fh = new FileHandler();
		
		try {
			List<File> list = fh.getFileListing(new File(dir));
			
			for (File f : list) {
				
			
				if (!f.isFile()) continue;
				
				if (!f.getName().contains("b")) continue;
				
				if (f.getName().startsWith("en")) continue;
				
				
				Scanner s = new Scanner(f);
				
				nof ++;
				while (s.hasNextLine()){
					String line = s.nextLine();
					
					now += line.split("\t").length;
					
					
					if (line.contains(word)) {
						System.out.println(nof + "\t"+now);
					return;
					}
				}
				
				
			}
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
	}

	
	int nof = 0;
	int now = 0;

	public void getExamples(String word, String dir, Writer out) {
		
		FileHandler fh = new FileHandler();
		
		try {
			List<File> list = fh.getFileListing(new File(dir));
			
			for (File f : list) {
				
			
				if (!f.isFile()) continue;
				
				if (!f.getName().contains("b")) continue;
				
				if (f.getName().startsWith("en")) continue;

				System.out.println(f.getAbsolutePath());
								
				getExamplesFromFile(word, f, out);
				
			}
			
			
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
	}
	
	
	public HashMap<String,MWERecord> 
		getExamplesMWE(ArrayList<String> MWEs) {
		
		
		HashMap<String,MWERecord> res = 
				new HashMap<String,MWERecord>();
		
		FileHandler fh = new FileHandler();
		
		try {
		
			List<File> list = fh.getFileListing(new File(mainDir));
			
			for (File f : list) {
				
			
				if (!f.isFile()) continue;

				System.out.println("Processing: "+f.getAbsolutePath());
				
				HashMap<String,ArrayList<String>> fileres = 
						getExamplesFromFileMWE(MWEs, f);
				
				for (String key : fileres.keySet()){
					
					if (!res.containsKey(key)){
						res.put(key, new MWERecord());
					}
					
					res.get(key).tfreq += fileres.get(key).size();
					res.get(key).dfreq += 1;
					res.get(key).examples.addAll(fileres.get(key));
					
					
				}
				
			}
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		return res;
		
	}

	public void getExamplesMWE(HashMap<String,String> MWEs, String dir, Writer out) {
		
		FileHandler fh = new FileHandler();
		
		try {
			List<File> list = fh.getFileListing(new File(dir));
			
			for (File f : list) {
				
			
				if (!f.isFile()) continue;
				
//				if (!f.getName().contains("b")) continue;
				
//				if (f.getName().startsWith("en")) continue;
				
				System.out.println("Processing: "+f.getAbsolutePath());
				
				getExamplesFromFileMWE(MWEs, f, out);
				
			}
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
	}
	

	public void getExamplesFromFile(String word, File f, Writer out)
			throws IOException{
		
		boolean hasMatch = false;
		
		Scanner s = new Scanner(f);
		
		nof++;
		
		while (s.hasNextLine()){
			
			String line = s.nextLine();
			
			now+= line.split(" ").length;
			
			if (line.toLowerCase().contains(word.toLowerCase())) {
					out.write(f.getAbsolutePath()
							+"\n");
				
				out.write(nof+"\t"+now+"\n");
				out.flush();
			}
		}
		
		s.close();
		
		
	}
	
	TextProcessor tp = new TextProcessor();
	
	public void getExamplesFromFileMWE(HashMap<String,String> MWEs, File f, Writer out) throws IOException{
		
		Scanner s = new Scanner(f);
		
		while (s.hasNextLine()){
			
			String line = s.nextLine();
			
			String[] sentences = line.split("\\.");
			
			for (String sent : sentences){
				String[] clauses = sent.split("[,\\.;:\"\\(\\)]");
				
				for (String clause : clauses){
					clause = " "+clause;
					for (String parts : MWEs.keySet()){
		
						boolean hasMatch = true;
							
						for (String part : parts.split(" ")){
		
							if (!clause.toLowerCase().contains(" "+part)) {
								
								hasMatch = false;
								break;
							}
						}
						
						if (hasMatch) {
							
							out.write(parts+"\t"+sent+"\n");
							out.flush();
	
						}
					}
				}
			}
		}

		s.close();
		
		
	}

	// real one
	public HashMap<String,ArrayList<String>> getExamplesFromFileMWE(
			ArrayList<String> MWEs, 
			File f) throws IOException{
		
		Scanner s = new Scanner(f);
		HashMap<String,ArrayList<String>> result = new HashMap<String,ArrayList<String>>();
		
		while (s.hasNextLine()){
			
			String line = s.nextLine();
			
			String[] sentences = line.split("\\.");
			
			for (String sent : sentences){
				String[] clauses = sent.split("[,\\.;:\"\\(\\)]");
				
				for (String clause : clauses){
					clause = " "+clause;
					for (String parts : MWEs){
						
						
						String[] pps = parts.split(" ");
//						System.out.println(parts+ " "+pps.length);
						if (pps.length<2) continue;
		
						boolean hasMatch = true;
							
						for (String part : pps){
							
							if (part.contains("(")) {
								part = part.substring(0,  part.indexOf("("));
								if (part.length()>8) part = part.substring(0,part.length()-3);
								else if (part.length()>6) part = part.substring(0,part.length()-2);
								else if (part.length()>4) part = part.substring(0,part.length()-1);
							
								if (!clause.toLowerCase().contains(" "+part)
										&& !clause.toLowerCase().startsWith(" "+part)) {
									
									hasMatch = false;
									break;
								}
								
//								for (String ss : new String[] {"о","б","в","г","д","з","к","л","п"})
//								if (clause.toLowerCase().contains(" "+part+" ")
//										|| clause.toLowerCase().contains(" "+part+ss+ " ")){
//									hasMatch = false;
//									break;
//								}
								
								System.out.println(clause);
								System.out.println("VERB" + part+"\t"+parts);
								

							} else {
			
		//						System.out.println("OTHER" + part);
								
								if (!clause.toLowerCase().contains(" "+part+" ")
										&& !clause.toLowerCase().startsWith(part+" ")
										&& !clause.toLowerCase().endsWith(" "+part)) {
									
									hasMatch = false;
									break;
								}
								
								System.out.println("OTHERR" + part);
								
							}
						}
						
						if (hasMatch) {
							System.out.println("\t\t"+parts);

							
							if (!result.containsKey(parts)) {
								result.put(parts, new ArrayList<String>());
							}
							
							result.get(parts).add(sent);
	
						}
					}
				}
			}
		}

		s.close();
		
		return result;
	}


	
	public void getExamplesFromFile(File f, Writer out) throws IOException{
		
		String sentenceTagged = "";

		boolean matchBegin = false;
		boolean addExample = false;
		
		Scanner s = new Scanner(f);
		
		int sentLen = 0;
		
		while (s.hasNextLine()){
			
			String line = s.nextLine();
			
			String[] data = line.split("\t");
			
			if (line.startsWith("<S")) {
				sentenceTagged = "";
				matchBegin = false;
				addExample = false;

				sentLen = 0;
			}

			if (line.startsWith("</S>") && addExample){
				String r = getExampleSentence(sentenceTagged);
				
				if (!r.trim().equals("")) out.write(r + "<br><br>\n\n");
				out.flush();
			}
			
			if (sentLen > 199) continue;
			
			
			if (data.length < 4) continue;

			sentLen ++;

			String pos = data[data.length-1].substring(0,1);
			String posFull = data[data.length-1];
			
			if (!matchBegin && pos.equals("D")) {
				System.out.print(data[0]+ ","+data[data.length-1]+ " ");
				matchBegin = true;
			}
			
			if (matchBegin 
					&& (pos.equals("A") || (pos.equals("V") && posFull.contains("q")))) {
				addExample = true;
				matchBegin = false;
				
				System.out.println(data[0]+ ","+data[data.length-1]+ "\n");
			}
			
			sentenceTagged += line + "\n";
			
		}

		s.close();
		
		
	}
	
	public String getExampleSentence(String sentenceTagged){
		
		String result = "";
		String[] words = sentenceTagged.split("\n");
		
		boolean matchBegin = false;
		boolean hasExample = false;
		
		String match = "";

		for (String word : words) {
			
			String[] data = word.split("\t");
						
			if (data.length < 4) continue;
			String pos = data[data.length-1].substring(0,1);
			String posFull = data[data.length-1];
			
			if (pos.equals("D")) {
				if (!matchBegin) matchBegin = true;

				match += data[0]+ ","+data[data.length-1] + " ";
				continue;
			}
			
			if (matchBegin
					&& (pos.equals("A") || (pos.equals("V") && posFull.contains("q")))) {
								
				match = "<font color=\"blue\">" + match + "</font>" + " "
						+ "<font color=\"red\">" + data[0]+ ","+data[data.length-1] + "</font>";
				result += match + " ";
				
				if (match.split(",").length < N) hasExample = false;
				else hasExample = true;
				
				match = "";
				matchBegin = false;
				
				continue;
			}

			if (matchBegin) {
				result += match + " ";
				match = "";
				matchBegin = false;
			}

			result += data[0]+ ","+data[data.length-1] + " ";
			
		}
		
		if (!hasExample) return "";

		return result;
	}
	
	
}
