package bg.bas.dcl.inflection;

import java.util.ArrayList;

public class FlectionModel {
	
	public String name = "";
	public String category = "";
	public String POS= "";
//	public ArrayList<String> components = new ArrayList<String>();
	public ArrayList<FormModel> formModels = new ArrayList<FormModel>();
	
	public FlectionModel (String line){
		initialise(line);
	}
	
	public void initialise(String line){
		
		String[] model = line.split("=");
		
		if (model.length<2) return;
		
		name = model[0].trim();
		
		String n = name;
		while (n.length()>0 
				&& n.charAt(0) > 'A'
				&& n.charAt(0) < 'Z'){
			POS += n.charAt(0);
			n = n.substring(1);
		}
		
		String[] formModelsStr = model[1].split("\\+");
		
		for (String fmts : formModelsStr){
			
			FormModel formmodel = new FormModel();
			
			fmts=fmts.trim();
			String[] form = fmts.split("/");
			
			String gram = form[1].trim();

			formmodel.tags = gram;
			
			String[] components = form[0].split(" ");
			
			for (String c :components) {
				
				FormComponentModification fcm = new FormComponentModification();

				for (int i = 1; i<20; i++) {
						if (c.startsWith("<"+i+">")) {
							c = c.substring(("<"+i+">").length());
							
							fcm.componentID = i;
							break;
						}
				}
						
				while (c.length()>0){
					String operation = "";
					
					if (c.startsWith("<")){
						operation = c.substring(0,c.indexOf(">")+1);
					} else {
						int end = c.indexOf("<");
						if (end == -1) end = c.length();
						operation = c.substring(0,end);
					}
				
					if (operation.length()>0) fcm.modifications.add(operation);
					c = c.substring(operation.length());
				}
				
				if (fcm.modifications.size()>0)
				System.out.println("FORM MODEL READ: "+fcm.componentID
						+" "+fcm.modifications.get(0));
				formmodel.formModification.add(fcm);
						
			}
			
			formModels.add(formmodel);
		}

		
	}
	
	public ArrayList<Form> generateForms(String fullword){
		
		String[] words = fullword.split(" ");

		ArrayList<Form> result = new ArrayList<Form>();

		System.out.println("Generating forms:");
		
		for (FormModel fm : formModels){
			String form = "";
			
			System.out.println("MAIN FORM: "+fm.tags);
			
			form = fm.generateForm(words);
			
			Form fform = new Form();
			fform.form = form;
			fform.mainform = fullword;
			fform.POS = POS;
			fform.category = category;
			fform.tags = fm.tags;
			
			result.add(fform);
		}
		
		return result;
	}


}
