package bg.bas.dcl.inflection.GUI;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.File;
import java.util.*;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSeparator;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import javax.swing.border.SoftBevelBorder;
import javax.swing.filechooser.FileNameExtensionFilter;

import org.json.simple.JSONArray;
import org.json.simple.JSONObject;

import bg.bas.dcl.MWE.MWEComponent;
import bg.bas.dcl.MWE.MWEProcessor;
import bg.bas.dcl.general.JSONProcessor;
import bg.bas.dcl.inflection.InitialParametersReader;

	public class InflectionVerifierGUI {
	
		HashMap<String,ArrayList<String>> parameters = new
				HashMap<String,ArrayList<String>>();
		JFrame frame;
	    Container container;
	    
	    MWEProcessor processor = new MWEProcessor();
	
	    public InflectionVerifierGUI(String initfile){
	    	
	    	parameters = InitialParametersReader.readInitParameters(initfile);
	    	
	    	
	    }

	    
	    public void setup(){
	    	
	       	  // main frame
	        frame = new JFrame("MWE editor");
	        container = frame.getContentPane();

	
	    	
	        frame.addWindowListener(
	      		    new WindowAdapter() {
	      		        public void windowClosing(WindowEvent e) {
	      		            exit();
	      		        }
	      		    }
	        );
	        frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
	 
	        frame.setJMenuBar(setupMenu());

//	        container.add(jtp,BorderLayout.CENTER);

	        frame.setSize(1100,700);
	        frame.setVisible(true);

	    }

	    MWEComponent mwe = new MWEComponent();
	    public void setup(final JSONObject obj){
	    	
	       	  // main frame
	        frame = new JFrame("MWE editor");
	        container = frame.getContentPane();

		    	JPanel leftpanel = new JPanel();
		    	leftpanel.setPreferredSize(new Dimension(500,500));
		    	
		    	JPanel rightpanel = new JPanel();
		    	rightpanel.setPreferredSize(new Dimension(500,500));
		    	
		    	leftpanel.setLayout(new BoxLayout(leftpanel, 
	        			BoxLayout.PAGE_AXIS));
		    	
		    	JPanel mwepanel = new JPanel();
		    	
		    	JSONArray comps = (JSONArray) obj.get("components");
		    	
	    		
//	    		JPanel compsetuppanel = new JPanel();
//	    		compsetuppanel.setPreferredSize(new Dimension(300,300));

		    	
		    	for (int i = 0; i<comps.size(); i++){
		    		
		    		JSONObject comp = (JSONObject) comps.get(i);
		    		
		    		JPanel comppanel = new JPanel();
		    		comppanel.setLayout(new BoxLayout(comppanel, 
		        			BoxLayout.PAGE_AXIS));
		    		
		    		JTextArea cta = new JTextArea();
		    		cta.setText(comp.get("lemma").toString());
		    		cta.setPreferredSize(new Dimension(150,20));
		    		cta.setMaximumSize(new Dimension(200,20));
		    		
		    	
//		    		JButton compeditbutton = new JButton("Edit");
		    		
//		    		compeditbutton.addActionListener(new ActionListener() {
                   	 
 //                       public void actionPerformed(ActionEvent e)
  //                      {
                         	
                        	


 //                       }
  //                  });
		    		
		    		comppanel.add(cta);

		    		JPanel compsetup = setupComponent(comp);
		    		comppanel.add(compsetup);
		    		
		    		comppanel.setBorder(new SoftBevelBorder(2));
		    		
		    		mwepanel.add(comppanel);
		    		
		    	}
		    	
		    	leftpanel.add(mwepanel);
		    	
		    	JPanel mwesetuppanel = new JPanel();
		    	
		    	JPanel overalltype = new JPanel();
		    	overalltype.add(new JLabel("Synt type: "));
		    	
		    	JTextArea stype = new JTextArea();
		    	stype.setPreferredSize(new Dimension(150,20));
		    	stype.setText(obj.get("synttype").toString());
		    	overalltype.add(stype);
		    	
		    	JPanel overallstype = new JPanel();
		    	overallstype.add(new JLabel("Sem type: "));
		    	
		    	JTextArea smtype = new JTextArea();
		    	smtype.setPreferredSize(new Dimension(150,20));
		    	smtype.setText(obj.get("semtype").toString());
		    	overallstype.add(smtype);
		    	
		    	
		    	// wordorder
		    	
		    	JPanel wType = new JPanel();
		    	
		    	JLabel wlabel = new JLabel("Possible word order:");
		    	wType.add(wlabel);
		    	
		    	int no = ((JSONArray)obj.get("components")).size();
		    	
		    	if (no == 2) {
		    		wType.add(new JCheckBox("1 2"));
		    		wType.add(new JCheckBox("2 1"));
		    	}    	
		    	if (no == 3) {
		    		wType.add(new JCheckBox("1 2 3"));
		    		wType.add(new JCheckBox("1 3 2"));
		    		wType.add(new JCheckBox("2 1 3"));
		    		wType.add(new JCheckBox("2 3 1"));
		    		wType.add(new JCheckBox("3 1 2"));
		    		wType.add(new JCheckBox("3 2 1"));
		    	}    	
	    	

		    	mwesetuppanel.add(overalltype);
		    	mwesetuppanel.add(overallstype);
		    	mwesetuppanel.add(wType);
		    	
		    	leftpanel.add(mwesetuppanel);
		    	
		    	final JTextArea jta = new JTextArea(10,40);
		    	JScrollPane scrollPane = new JScrollPane(jta); 
		    	jta.setEditable(false);
		    	
		    	
		    	JButton generatebutton = new JButton ("Generate forms");
		    	
		    	generatebutton.addActionListener(new ActionListener() {
//		    		comppanel.add(compeditbutton);

                    public void actionPerformed(ActionEvent e)
                    {
                     	
                   	String forms = generateForms(obj);
                   	jta.setText(forms);


                    }
                });
	
		    	rightpanel.add(generatebutton);
		    	rightpanel.add(scrollPane);
			    	
		    	container.add(leftpanel,BorderLayout.WEST);
		    	container.add(rightpanel,BorderLayout.EAST);

	
	    	
	        frame.addWindowListener(
	      		    new WindowAdapter() {
	      		        public void windowClosing(WindowEvent e) {
	      		            exit();
	      		        }
	      		    }
	        );
	        frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
	 
	        frame.setJMenuBar(setupMenu());

//	        container.add(jtp,BorderLayout.CENTER);

	        frame.setSize(1100,700);
	        frame.setVisible(true);

	    }
	    
	    public String generateForms(JSONObject obj){
	    	String res = "";
	    	String lemma = (String) obj.get("lemma");
	    	String[] forms = {"съм","си","е","сме","сте","са",
	    			"бях","беше","бе","бяхме","бяхте","бяха",
	    			"съм бил","си бил","е бил","сме били","сте били","са били"};
	    	String[] forms1 = {"вдигам","вдигаш","вдига","вдигаме","вдигате",
	    			"вдигат","вдигах","вдигаше","вдига","вдигахме","вдигахте",
	    			"вдигаха","съм вдигал","си вдигал","е вдигал","сме вдигали",
	    			"сте вдигали","са вдигали"};
	    	
	    	if (lemma.contains("съм")) for (String f : forms) res += lemma.replace("съм", f)+"\n";
	    	if (lemma.contains("вдигам")) for (String f : forms1) res += lemma.replace("вдигам", f)+"\n";
	    	
	    	return res;
	    }
	    
	    public JPanel setupComponent(JSONObject comp){
	    	
	    	JPanel panel = new JPanel();
	    	
	    	// synt type
	    	String gr = (String) comp.get("gram");
	    	JPanel syntType = new JPanel();
	    	String[] syntoptions = {"V","NP","AP","AdvP","PP"};
	    	
	    	JLabel syntlabel = new JLabel("Synt type:");
	    	
	    	JComboBox syntList = new JComboBox(syntoptions);
	    	if (gr.startsWith("V")) syntList.setSelectedIndex(0);
	    	if (gr.startsWith("N")) syntList.setSelectedIndex(1);
	    	if (gr.startsWith("A")) syntList.setSelectedIndex(2);
	    	if (gr.startsWith("D")) syntList.setSelectedIndex(3);
	    	if (gr.startsWith("P")) syntList.setSelectedIndex(4);
	    	
	    	syntType.add(syntlabel);
	    	syntType.add(syntList);
	    	
	    	panel.add(syntType);
	    	
	    	//head
	    	
	    	JCheckBox box = new JCheckBox();
	    	box.setText("Head:");
	    	
	    	panel.add(box);
	    	
	    	// infl type
	    	
	    	String[] NPoptions = {"NHS0","NHS1","NHS1","NHS1","NHP0","NHP1","NHP2"};
	    	String[] PPoptions = {"P_NHS0","P_NHS1","P_NHS1","P_NHS1","P_NHP0",
	    			"P_NHP1","P_NHP2"};
	    	String[] Voptions = {"V0","VI1","VI2","VI3","VP1","VP2","VP3",
	    			"VI13","VI23","VI33"};
	    	
	    	JPanel inflType = new JPanel();
	    	
	    	JLabel infllabel = new JLabel("Flection type:");
	    	
	    	JComboBox inflList = new JComboBox();

	    	if (gr.startsWith("V")) inflList = new JComboBox(Voptions);
	    	if (gr.startsWith("N")) inflList = new JComboBox(NPoptions);
	    	if (gr.startsWith("P")) inflList = new JComboBox(PPoptions);
	    	
	    	inflType.add(infllabel);
	    	inflType.add(inflList);
	    	
	    	panel.add(inflType);
	    	
	    	JPanel modType = new JPanel();
	    	JLabel modlabel = new JLabel("Modifiers:");
	    	
	    	JComboBox modList = new JComboBox();

	    	String[] mNPoptions = {"A","Adv","N","B","All"};
	    	String[] mPPoptions = {"P_A","P_Adv","P_N","P_B","P_All"};
	    	String[] mVoptions = {"Adv","PP","N"};

	    	if (gr.startsWith("V")) modList = new JComboBox(mVoptions);
	    	if (gr.startsWith("N")) modList = new JComboBox(mNPoptions);
	    	if (gr.startsWith("P")) modList = new JComboBox(mPPoptions);
	    	
	    	modType.add(modlabel);
	    	modType.add(modList);
	    	
	    	panel.add(modType);
	    	

	    	// external
	    	
	    	
	    	return panel;
	    	
	    }
	    
	    public JPanel load(MWEComponent mwe){
	    	
	    	JPanel panel = new JPanel(new BorderLayout());
	    	
	    	panel.add(new JLabel("OTHER LABEL"));
	    	
	    	return panel;
	       
	    }


	    
	    public MWEComponent loadMWE(String line){
	    	
	    	String[] data = line.split("\t");
	    	
	    	String[] components = data[0].split(" ");
	    	
	    	MWEComponent MWE = new MWEComponent();

	    	int i = -1;
	    	
	    	for (String comp : components) {
	    		
	    		if (comp.equals("(")) {
	    			MWE.add(new MWEComponent());
	    			i = MWE.size()-1;
	    		} else if (comp.equals(")")) {
	    			MWE.get(i).full = true;
	    			
	    			for (int j = i-1; j>-1; j--) {
	    				if (!MWE.get(j).full){
	    					i = j;
	    					break;
	    				}
	    			}
	    		} else {
	    			MWE.get(i).lemma += comp + " ";
	    		}
	    		

	    	}
	    	
	    	System.out.println(MWE.toString());
	    	return MWE;
	    	
	    }

	    public JMenuBar setupMenu(){
	    	JMenuBar menu = new JMenuBar();
	 
	       	JMenu fileMenu = new JMenu("Файл");
	       	fileMenu.setMnemonic(KeyEvent.VK_F);
	       	String[] fileItems = new String[] {"Създай нов","Отвори","Излез"};
	       	char[] fileShortcuts = new char[] {'N','O','X'};
	 
	       	JMenu editMenu = new JMenu("Редакция");
	       	editMenu.setMnemonic(KeyEvent.VK_E);
	       	String[] editItems = new String[] {"Синхронизирай английски",
	       			"Намери в текста", "Замени в текста"};
	       	char[] editShortcuts = new char[] {'Y','F','R'};
	       	
	       	    	
	       	JMenu helpMenu = new JMenu("Помощ");
	       	helpMenu.setMnemonic(KeyEvent.VK_H);
	       	String[] helpItems = new String[] {"Информация","Ръководство"};
	       	char[] helpShortcuts = new char[] {'A','M'};
	       	
	      
	       	ActionListener exitListener = new ActionListener(){
	       		public void actionPerformed(ActionEvent e){
	       			
	       			exit();
	       		}
	       	};
	       	
	       	ActionListener newListener = new ActionListener(){
	       		public void actionPerformed(ActionEvent e){
	       			
	       			load(new MWEComponent());
	      		}
	       	};

	       	ActionListener openListener = new ActionListener(){
	       		public void actionPerformed(ActionEvent e){
	       			
	       			openNew();
	      		}
	       	};


	       	ActionListener findListener = new ActionListener(){
	       		public void actionPerformed(ActionEvent e){
	       			
	       			String word = (String)JOptionPane.showInputDialog(
	                        frame,
	                        "Find: ",
	                        "Find dialog",
	                        JOptionPane.PLAIN_MESSAGE,
	                        null,
	                        null,
	                        "");

	       			
	        	}
	       	};

	       	ActionListener replaceListener = new ActionListener(){
	       		public void actionPerformed(ActionEvent e){
	        	  JTextField xField = new JTextField(5);
	       	      JTextField yField = new JTextField(5);

	       	      JPanel myPanel = new JPanel();
	       	      myPanel.add(new JLabel("Намери:"));
	       	      myPanel.add(xField);
	       	      myPanel.add(Box.createHorizontalStrut(15)); // a spacer
	       	      myPanel.add(new JLabel("Замени с:"));
	       	      myPanel.add(yField);

	       	      int result = JOptionPane.showConfirmDialog(null, myPanel, 
	       	               "Find and replace", JOptionPane.OK_CANCEL_OPTION);
	  

	       			
	       			
	        	}
	       	};

	       	ActionListener closeListener = new ActionListener(){
	       		public void actionPerformed(ActionEvent e){
	       			
	    			int n = JOptionPane.showConfirmDialog(
	    				    frame,
	    				    "Запазихте ли промените?! Искате ли да продължите?",
	    				    "Запазихте ли промените",
	    				    JOptionPane.YES_NO_OPTION);
				
	    		if (n==0){

	       			

	    		} else {
	    			System.out.println("Close file cancelled ");
					
				}
	        	}
	       	};

	       	
	       	ActionListener manualListener = new ActionListener(){
	       		public void actionPerformed(ActionEvent e){
	       			
	       			JPanel panel = new JPanel();
	       			
	        		}
	       	};

	       	ActionListener aboutListener = new ActionListener(){
	       		public void actionPerformed(ActionEvent e){
	       			JOptionPane.showMessageDialog(frame,
	       				    "<html>InflectionGenerator 1.0<br>Секция по компютърна лингвистика &copy; 2014</html>",
	       				    "Информация",
	       				    JOptionPane.PLAIN_MESSAGE);
	       		}
	       	};
	       	
	      	ActionListener[] fileListeners = new ActionListener[] {
	       			newListener, openListener, exitListener};

	       	
	       	for (int i=0; i< fileItems.length; i++){
	    		JMenuItem item = new JMenuItem(fileItems[i],fileShortcuts[i]);
	    		item.addActionListener(fileListeners[i]);
	    		fileMenu.add(item);
	    		
	    		if (fileItems[i].equals("Отвори")) fileMenu.addSeparator();
	    		if (fileItems[i].equals("Запази и отвори")) fileMenu.addSeparator();
	      	}

	       	
	       	JMenu submenu = new JMenu("Възстанови последния запазен вариант");
	       	submenu.setMnemonic(KeyEvent.VK_S);


	       	menu.add(fileMenu);
	       	menu.add(editMenu);
	       	menu.add(helpMenu);

	      	menu.add(helpMenu);

	     	menu.add(new JSeparator(SwingConstants.VERTICAL));

	      	JButton checkspellingbutton = new JButton();
	      	menu.add(checkspellingbutton);
	      	
	      	JLabel l = new JLabel("<html><font color='blue' size='5'> ?</font></html>");
			l.addMouseListener(new MouseListener(){
				
				@Override
				public void mouseClicked(MouseEvent e) {
					// TODO Auto-generated method stub
					JOptionPane.showMessageDialog(
							frame, " ");
				}

				@Override
				public void mousePressed(MouseEvent e) {
					// TODO Auto-generated method stub
				}

				@Override
				public void mouseReleased(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

				@Override
				public void mouseEntered(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}

				@Override
				public void mouseExited(MouseEvent e) {
					// TODO Auto-generated method stub
					
				}
				
				
			});

	      	menu.add(l);

	      	menu.add(new JSeparator(SwingConstants.VERTICAL));


			return menu;
	 
		}
	    
	    String currentDir = "";
	    public void openNew(){
	    	
	 		JFileChooser chooser = new JFileChooser(
					currentDir);
	 		
			
			 FileNameExtensionFilter filter = 
					 new FileNameExtensionFilter(
				        "JSON files", "json", "JSON");
			 chooser.setFileFilter(filter);
				    
			int option = chooser.showOpenDialog(frame);
			
			if (option == JFileChooser.APPROVE_OPTION) {
				File f = chooser.getSelectedFile();
				
				JSONProcessor jp = new JSONProcessor();
				
				JSONObject object = jp.readJSON(f);
				
				setup(object);
				currentDir = f.getParent();
				
			}

	    }
   
	    

	    /**
	     * opens a confirm dialog before closing
	     * 
	     */
	    void exit()
	    {
	            // confirm dialog
	            int confirmed = JOptionPane.showConfirmDialog(frame,
	                    "Are you sure you want to exit?", "Confirm exit",
	                    JOptionPane.YES_NO_OPTION);
	           
	            if (confirmed == JOptionPane.YES_OPTION)
	            {                            
	                    frame.dispose();
	                    
	                    
	            }
//	            mainsugpanel.setVisible(false);
	    }

	
	}
