package bg.bas.dcl.inflection;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;
import java.io.Writer;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Scanner;

public class InflectionGenerator {
	
	public static HashMap<String,String> allStored = 
			new HashMap<String,String>();

	
	public static HashMap<String,ArrayList<String>> parameters = 
			new HashMap<String,ArrayList<String>>();
	
	public static HashMap<String,FlectionModel> models = 
			new HashMap<String,FlectionModel>();
		
	public static void main(String[] args){
		
		String initfile = "/home/ivelina/WORK-DCL/MWE-DICTS/TYPES-2015-08-20/"
				+ "initparam.txt";
		
		if (args.length>0) {
			initfile = args[0];
		}
		parameters = InitialParametersReader.readInitParameters(initfile);
		
		allStored = readAllStored(parameters.get("output-folder").get(0),
				1,2,false);
		models = readAllModels(parameters.get("flect-types-file").get(0));
		
		System.out.println("MODELS READ: "+models.size());
		
		try {
			
//			processAllFilesWithSamples();
			processAllFiles();
			
			
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}


	}
	
	public InflectionGenerator(){
		
		String initfile = "/home/ivelina/WORK-DCL/MWE-DICTS/TYPES-2015-08-20/"
				+ "initparam.txt";
		
		parameters = InitialParametersReader.readInitParameters(initfile);
		
		allStored = readAllStored(parameters.get("output-folder").get(0),
				1,2,false);
		models = readAllModels(parameters.get("flect-types-file").get(0));
		
		System.out.println("MODELS READ: "+models.size());
		
		try {
			
//			processAllFilesWithSamples();
			processAllFiles();
			
			
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}


	}
	
	public static HashMap<String,FlectionModel> readAllModels(String filename){
		
		HashMap<String,FlectionModel> result = new HashMap<String,FlectionModel>();
		
		try{
						
			Scanner s = new Scanner (new File(filename));

			while (s.hasNextLine()){
				String line = s.nextLine();
				
				if (line.startsWith("#")) continue;
				
	
				FlectionModel fm = new FlectionModel(line);
				System.out.println(line);
				System.out.println("MODEL READ: "+fm.name
						+ " " + fm.POS
						+ " " + fm.formModels.size());
			
				result.put(fm.name, fm);
			}

			
			s.close();
			
		}catch(Exception e){
			e.printStackTrace();
		}
		
		
		return result;
		
	}
	
	public static HashMap<String,String> readAllStored(
			String folder,int k, int j, boolean full){
		
		HashMap<String,String> result
			= new HashMap<String,String>();
		
		try{
			File inf = new File(folder);
			List<File> list = new ArrayList<File>();
			
			if (inf.isDirectory()){
				list = FileHandler.getFileListing(inf);
			} else {
				list.add(inf);
			}
			
			for (File f : list) {
				
				System.out.println(f.getAbsolutePath());
				if (!f.isFile()) continue;
				if (!f.getName().endsWith(".txt")) continue;
				
			
				Scanner s = new Scanner (f);
	
				while (s.hasNextLine()){
					
					String line = s.nextLine();
					
					System.out.println(line);
					
					if (line.startsWith("#")) continue;
					
					String[] data = line.trim().split("[\\.,]");
		
					if (data.length<=Math.max(k, j)) continue;

					String tag = data[j].substring(0, 4);
					if (!tag.endsWith("S") && !tag.endsWith("P")){
						tag = tag.substring(0, 3);
					}
					
					if (full) result.put(data[k], data[j]);
					else result.put(data[k], tag);
				}
	
				
				s.close();
			}
		}catch(Exception e){
			e.printStackTrace();
		}
		
		
		return result;
		
	}

	
	public static void processAllFiles(){
		
		int ctrall = 0;
		int ctrfalty = 0;
		int ctr = 0;
		int ctrf = 0;
		try{
			
			List<File> list = FileHandler.getFileListing(
					new File(parameters.get("input-folder").get(0)));
			
			
			for (File f : list){
				
				if (!f.isFile()) continue;
				if (!f.getName().endsWith(".txt")) continue;
				
	
				Scanner s = new Scanner (f, "UTF-8");

				String outf = f.getAbsolutePath()
						.replace(parameters.get("input-folder").get(0), 
								parameters.get("output-folder").get(0));
				File outff = new File(outf);
				Writer out = new OutputStreamWriter(
						new FileOutputStream(outff),"UTF-8");

				String outerrf = f.getAbsolutePath()
						.replace(parameters.get("input-folder").get(0), 
								parameters.get("error-folder").get(0));
				File outerrff = new File(outerrf);
				Writer outerr = new OutputStreamWriter(
						new FileOutputStream(outerrf),"UTF-8");
	
				while (s.hasNextLine()){
					String line = s.nextLine().trim();
					
					if (line.contains("\t")) {
						line = line.substring(0,line.indexOf("\t"));
					}
					
					if (line.length()==0) continue;
					if (line.startsWith("#")) continue;
					
					ctrall ++;

					if (line.startsWith("0"))continue;
					if (line.startsWith("1")
							|| line.startsWith("2")
							|| line.startsWith("3")
							|| line.startsWith("4")
							|| line.startsWith("5")
							|| line.startsWith("6")) {
						outerr.write(line+"\n");
						outerr.flush();
						
						ctrfalty++;
						continue;
					}

					String[] data = line.split("[\\.,]");
					if (data.length<2) continue;
					
					if (allStored.containsKey(data[0])){
						if (!allStored.get(data[0]).equals(data[1])){
							outerr.write("99" + line
									+ "\t" + data[0]
									+ "," + allStored.get(data[0])
									+ "\n");
							outerr.flush();
						}
						continue;
					} else {
						allStored.put(data[0],data[1]);
					}
					
					String category = getCategoryfromFilename(f.getName());

					ArrayList<Form> forms = generateForms(line, category);
					
					ctr++;
					
					for (Form ff : forms) {
						ctrf++;
						out.write(ff.toString());
						out.write("\n");
						out.flush();
						System.out.println(ff);
					}


				}

				out.flush();
				out.close();
				outerr.flush();
				outerr.close();
				

				if (outff.length() == 0) outff.delete();
				if (outerrff.length() == 0) outerrff.delete();
				
				s.close();
				
			}
			System.out.println("TOTAL CHECKED: "+ ctrall+" TOTAL WORDS: "+ ctr+" TOTAL FORMS: "+ctrf
					+" TOTAL FAULTY: "+ ctrfalty);
			
		}catch(Exception e){
			e.printStackTrace();
		}
		
	}
	
	
	public static void processAllFilesWithSamples(){
		
		int ctrall = 0;
		int ctrfalty = 0;
		int ctr = 0;
		int ctrf = 0;
		try{
			
			List<File> list = FileHandler.getFileListing(
					new File(parameters.get("input-folder").get(0)));
			
			
			for (File f : list){
				
				if (!f.isFile()) continue;
				if (!f.getName().endsWith(".txt")) continue;
				
	
				Scanner s = new Scanner (f, "UTF-8");

				String outf = f.getAbsolutePath()
						.replace(parameters.get("input-folder").get(0), 
								parameters.get("output-folder").get(0));
				File outff = new File(outf);
				Writer out = new OutputStreamWriter(
						new FileOutputStream(outff),"UTF-8");

				String outerrf = f.getAbsolutePath()
						.replace(parameters.get("input-folder").get(0), 
								parameters.get("error-folder").get(0));
				File outerrff = new File(outerrf);
				Writer outerr = new OutputStreamWriter(
						new FileOutputStream(outerrf),"UTF-8");
	
				while (s.hasNextLine()){
					String line = s.nextLine().trim();
					
					if (line.contains("\t")) {
						line = line.substring(0,line.indexOf("\t"));
					}
					
					if (line.length()==0) continue;
					if (line.startsWith("#")) continue;
					
					ctrall ++;

					if (line.startsWith("0"))continue;
					if (line.startsWith("1")
							|| line.startsWith("2")
							|| line.startsWith("3")
							|| line.startsWith("4")
							|| line.startsWith("5")
							|| line.startsWith("6")) {
						outerr.write(line+"\n");
						outerr.flush();
						
						ctrfalty++;
						continue;
					}

					String[] data = line.split("[\\.,]");
					if (data.length<2) continue;
					
					if (allStored.containsKey(data[0])){
						if (!allStored.get(data[0]).equals(data[1])){
							outerr.write("99" + line
									+ "\t" + data[0]
									+ "," + allStored.get(data[0])
									+ "\n");
							outerr.flush();
						}
						continue;
					} else {
						allStored.put(data[0],data[1]);
					}
					
					String category = getCategoryfromFilename(f.getName());

					ArrayList<Form> forms = generateForms(line, category);
					
					ctr++;
					
					out.write(line);
					out.write("\t");
					out.flush();
					
					for (Form ff : forms) {
						ctrf++;
						out.write(ff.form);
						out.write("\t");
						out.flush();
						System.out.println(ff);
					}
					out.write("\n");
					out.flush();
				}

				out.flush();
				out.close();
				outerr.flush();
				outerr.close();
				

				if (outff.length() == 0) outff.delete();
				if (outerrff.length() == 0) outerrff.delete();
				
				s.close();
				
			}
			System.out.println("TOTAL CHECKED: "+ ctrall+" TOTAL WORDS: "+ ctr+" TOTAL FORMS: "+ctrf
					+" TOTAL FAULTY: "+ ctrfalty);
			
		}catch(Exception e){
			e.printStackTrace();
		}
		
	}

	public static String getCategoryfromFilename(String fname){
		
		return fname.substring(0,1);
	}
	
	public static ArrayList<Form> generateForms(String line, String category){
		
		
		ArrayList<Form> forms = new ArrayList<Form>();
		
		String[] parts = line.split(",");
		
		if (parts.length < 2) return forms;
		
		String type = parts[1].trim();
		
//		System.out.println("GENERATE FORMS " + type + "/"+models.size());
		
		System.out.println("LINE "+line);
		
		if (models.containsKey(type)){
//			System.out.println("GENERATE FORMS "+models.get(type).name);
			
			FlectionModel fm = models.get(type);
			fm.category = category;
			forms.addAll(fm.generateForms(parts[0]));
		}
		
//		System.out.println(line);
//		System.out.println("FORMS GENERATED: "+forms.size());

		return forms;
	}
	

}
