package bg.bas.dcl.inflection;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;
import java.io.Writer;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Scanner;

import bg.bas.dcl.MWE.MWEComponent;

public class InflectionGeneratorFeatures {
	
	public static HashMap<String,ArrayList<String>> parameters = 
			new HashMap<String,ArrayList<String>>();
	
	public static HashMap<String,FlectionModel> models = 
			new HashMap<String,FlectionModel>();
		
		
		String initfile = "/home/ivelina/WORK-DCL/MWE-DICTS/TYPES-2015-08-20/"
				+ "initparam.txt";
		
	public InflectionGeneratorFeatures (String initfile){
			this.initfile = initfile;
	}
		
	public void setup(){
		
		parameters = InitialParametersReader.readInitParameters(initfile);

		models = readAllModels(parameters.get("flect-types-file").get(0));
		
		System.out.println("BASE MODELS READ: " + models.size());
		
	}
	
	public static HashMap<String,FlectionModel> readAllModels(String filename){
		
		HashMap<String,FlectionModel> result = new HashMap<String,FlectionModel>();
		
		try{
						
			Scanner s = new Scanner (new File(filename));

			while (s.hasNextLine()){
				String line = s.nextLine();
				
				if (line.startsWith("#")) continue;
				
	
				FlectionModel fm = new FlectionModel(line);
				System.out.println(line);
				System.out.println("MODEL READ: "+fm.name
						+ " " + fm.POS
						+ " " + fm.formModels.size());
			
				result.put(fm.name, fm);
			}

			
			s.close();
			
		}catch(Exception e){
			e.printStackTrace();
		}
		
		
		return result;
		
	}
		
	
	public static void processAllFilesWithSamples(){
		
		int ctrall = 0;
		int ctrfalty = 0;
		int ctr = 0;
		int ctrf = 0;
		try{
			
			List<File> list = FileHandler.getFileListing(
					new File(parameters.get("input-folder").get(0)));
			
			
			for (File f : list){
				
				if (!f.isFile()) continue;
				if (!f.getName().endsWith(".txt")) continue;
				
	
				Scanner s = new Scanner (f, "UTF-8");

				String outf = f.getAbsolutePath()
						.replace(parameters.get("input-folder").get(0), 
								parameters.get("output-folder").get(0));
				File outff = new File(outf);
				Writer out = new OutputStreamWriter(
						new FileOutputStream(outff),"UTF-8");

				String outerrf = f.getAbsolutePath()
						.replace(parameters.get("input-folder").get(0), 
								parameters.get("error-folder").get(0));
				File outerrff = new File(outerrf);
				Writer outerr = new OutputStreamWriter(
						new FileOutputStream(outerrf),"UTF-8");
	
				while (s.hasNextLine()){
					String line = s.nextLine().trim();
					
					if (line.contains("\t")) {
						line = line.substring(0,line.indexOf("\t"));
					}
					
					if (line.length()==0) continue;
					if (line.startsWith("#")) continue;
					
					ctrall ++;


					String[] data = line.split("[\\.,]");
					if (data.length<2) continue;
					
					String category = getFlexType( new MWEComponent() );

					ArrayList<Form> forms = generateForms(line, category);
					
					ctr++;
					
					out.write(line);
					out.write("\t");
					out.flush();
					
					for (Form ff : forms) {
						ctrf++;
						out.write(ff.form);
						out.write("\t");
						out.flush();
						System.out.println(ff);
					}
					out.write("\n");
					out.flush();
				}

				out.flush();
				out.close();
				outerr.flush();
				outerr.close();
				

				if (outff.length() == 0) outff.delete();
				if (outerrff.length() == 0) outerrff.delete();
				
				s.close();
				
			}
			System.out.println("TOTAL CHECKED: "+ ctrall+" TOTAL WORDS: "+ ctr+" TOTAL FORMS: "+ctrf
					+" TOTAL FAULTY: "+ ctrfalty);
			
		}catch(Exception e){
			e.printStackTrace();
		}
		
	}

	public static String getFlexType(MWEComponent comp){
		
		
		return "";
	}
	
	public static ArrayList<Form> generateForms(String line, String category){
		
		
		ArrayList<Form> forms = new ArrayList<Form>();
		
		String[] parts = line.split(",");
		
		if (parts.length < 2) return forms;
		
		String type = parts[1].trim();
		
//		System.out.println("GENERATE FORMS " + type + "/"+models.size());
		
		System.out.println("LINE "+line);
		
		if (models.containsKey(type)){
//			System.out.println("GENERATE FORMS "+models.get(type).name);
			
			FlectionModel fm = models.get(type);
			fm.category = category;
			forms.addAll(fm.generateForms(parts[0]));
		}
		
//		System.out.println(line);
//		System.out.println("FORMS GENERATED: "+forms.size());

		return forms;
	}
	

}
